## clasp 3.3.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1)
project(CLASP VERSION 3.3.0 LANGUAGES CXX)
# Enable folders in IDEs like Visual Studio
set_property(GLOBAL PROPERTY USE_FOLDERS ON)
if (POLICY CMP0063)
	cmake_policy(SET CMP0063 NEW)
endif()
if (NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
	message(STATUS "No build type selected - using 'Release'")
	set(CMAKE_BUILD_TYPE "Release")
endif()
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

# Configuration options
option(CLASP_BUILD_APP          "whether or not to build the clasp application" ON)
option(CLASP_BUILD_STATIC       "whether or not to link statically (if supported)" OFF)
option(CLASP_BUILD_TESTS        "whether or not to build clasp unit tests" OFF)
option(CLASP_BUILD_EXAMPLES     "whether or not to build examples" OFF)
option(CLASP_BUILD_WITH_THREADS "whether or not to build clasp with threading support (requires C++11)" ON)
option(CLASP_INSTALL_LIB        "whether or not to install libclasp" OFF)

if (NOT MSVC)
	if (NOT CMAKE_ARCHIVE_OUTPUT_DIRECTORY)
		set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
	endif()
	if (NOT CMAKE_LIBRARY_OUTPUT_DIRECTORY)
		set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)
	endif()
	if (NOT CMAKE_RUNTIME_OUTPUT_DIRECTORY)
		set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)
	endif()
else()
	set(VC_RELEASE_LINK_OPTIONS /LTCG)
	SET(CMAKE_EXE_LINKER_FLAGS_RELEASE    "${CMAKE_EXE_LINKER_FLAGS_RELEASE}    ${VC_RELEASE_LINK_OPTIONS}")
	SET(CMAKE_MODULE_LINKER_FLAGS_RELEASE "${CMAKE_MODULE_LINKER_FLAGS_RELEASE} ${VC_RELEASE_LINK_OPTIONS}")
	SET(CMAKE_SHARED_LINKER_FLAGS_RELEASE "${CMAKE_SHARED_LINKER_FLAGS_RELEASE} ${VC_RELEASE_LINK_OPTIONS}")
	SET(CMAKE_STATIC_LINKER_FLAGS_RELEASE "${CMAKE_STATIC_LINKER_FLAGS_RELEASE} ${VC_RELEASE_LINK_OPTIONS}")
	if (CLASP_BUILD_STATIC)
		# force static runtime
		string(REGEX REPLACE "/MD" "/MT" CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE}")
	endif()
endif()
set(clasp_include_dest  "include/clasp-${CLASP_VERSION}")
set(clasp_library_dest "lib/clasp-${CLASP_VERSION}")

# C++11 is required for building with threads
if (CLASP_BUILD_WITH_THREADS)
	set(CMAKE_CXX_STANDARD 11)
	set(CMAKE_CXX_STANDARD_REQUIRED ON)
	set(CMAKE_CXX_EXTENSIONS OFF)
	# some versions of findThreads will fail if C is not enabled
	enable_language(C)
	find_package(Threads REQUIRED)
endif()

# Check for and optionally build external dependency
find_package(potassco 1.0 QUIET CONFIG)
if (NOT potassco_FOUND)
	if (NOT EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/libpotassco/CMakeLists.txt)
		message(STATUS "Potassco is not installed - fetching submodule")
		execute_process(COMMAND git submodule update --init WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} OUTPUT_QUIET)
	else()
		message(STATUS "Potassco is not installed - using local copy")
	endif()
	set(LIB_POTASSCO_BUILD_APP   ${CLASP_BUILD_APP}   CACHE BOOL "")
	set(LIB_POTASSCO_INSTALL_LIB ${CLASP_INSTALL_LIB} CACHE BOOL "")
	add_subdirectory(libpotassco)
endif()

# Build clasp library
add_subdirectory(src)

# Build optional targets
if(CLASP_BUILD_TESTS)
	enable_testing()
	add_subdirectory(tests)
endif()
# optional doc target
find_package(Doxygen)
if(DOXYGEN_FOUND)
	set(doxyfile "${CMAKE_CURRENT_SOURCE_DIR}/doc/api/clasp.doxy")
	add_custom_target(doc_clasp
		COMMAND ${DOXYGEN_EXECUTABLE} ${doxyfile}
		WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/doc/api"
		COMMENT "Generating documentation..."
		VERBATIM)
	set_target_properties(doc_clasp PROPERTIES FOLDER doc)
endif()

if(CLASP_BUILD_APP)
	add_subdirectory(app)
endif()

if(CLASP_BUILD_EXAMPLES)
	add_subdirectory(examples)
endif()

# Export
configure_file(cmake/clasp-config-version.cmake.in
	${CMAKE_CURRENT_BINARY_DIR}/clasp-config-version.cmake
	@ONLY)
if (CLASP_INSTALL_LIB)
	install(FILES cmake/clasp-config.cmake ${CMAKE_CURRENT_BINARY_DIR}/clasp-config-version.cmake DESTINATION "${clasp_library_dest}")
	install(EXPORT clasp DESTINATION "${clasp_library_dest}")
endif()

=== app/CMakeLists.txt ===
set(files
	clasp_app.cpp
	clasp_app.h
	main.cpp)
add_executable(clasp ${files})
set_target_properties(clasp PROPERTIES FOLDER exe)
if (CLASP_BUILD_STATIC AND UNIX AND NOT APPLE)
	if (CLASP_BUILD_WITH_THREADS)
		string(CONCAT refs "-Wl,-u,pthread_cancel,-u,pthread_cond_broadcast,"
		                   "-u,pthread_cond_destroy,-u,pthread_cond_signal,"
		                   "-u,pthread_cond_timedwait,-u,pthread_cond_wait,"
		                   "-u,pthread_create,-u,pthread_detach,-u,pthread_join,"
		                   "-u,pthread_equal")
		target_link_libraries(clasp ${refs})
	endif()
	target_link_libraries(clasp "-static")
endif()
target_link_libraries(clasp libclasp)

install(TARGETS clasp EXPORT clasp DESTINATION "bin")

=== libpotassco/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1)
project(LIB_POTASSCO VERSION 1.0 LANGUAGES CXX)
if (POLICY CMP0063)
	cmake_policy(SET CMP0063 NEW)
endif()
# enable folders in IDEs like Visual Studio
set_property(GLOBAL PROPERTY USE_FOLDERS ON)

option(LIB_POTASSCO_BUILD_TESTS "whether or not to build tests"          OFF)
option(LIB_POTASSCO_BUILD_APP   "whether or not to build lpconvert tool" ON)
option(LIB_POTASSCO_INSTALL_LIB "whether or not to install libpotassco"  OFF)
set(include_dest  "include/potassco-${LIB_POTASSCO_VERSION}")
set(library_dest  "lib/potassco-${LIB_POTASSCO_VERSION}")

if (NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
	message(STATUS "No build type selected - using 'Release'")
	set(CMAKE_BUILD_TYPE "Release")
endif()

if (NOT MSVC)
	if (NOT CMAKE_ARCHIVE_OUTPUT_DIRECTORY)
		set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
	endif()
	if (NOT CMAKE_LIBRARY_OUTPUT_DIRECTORY)
		set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)
	endif()
	if (NOT CMAKE_RUNTIME_OUTPUT_DIRECTORY)
		set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)
	endif()
else()
    set(VC_RELEASE_LINK_OPTIONS /LTCG)
	SET(CMAKE_EXE_LINKER_FLAGS_RELEASE    "${CMAKE_EXE_LINKER_FLAGS_RELEASE}    ${VC_RELEASE_LINK_OPTIONS}")
	SET(CMAKE_MODULE_LINKER_FLAGS_RELEASE "${CMAKE_MODULE_LINKER_FLAGS_RELEASE} ${VC_RELEASE_LINK_OPTIONS}")
	SET(CMAKE_SHARED_LINKER_FLAGS_RELEASE "${CMAKE_SHARED_LINKER_FLAGS_RELEASE} ${VC_RELEASE_LINK_OPTIONS}")
	SET(CMAKE_STATIC_LINKER_FLAGS_RELEASE "${CMAKE_STATIC_LINKER_FLAGS_RELEASE} ${VC_RELEASE_LINK_OPTIONS}")
endif()

add_subdirectory(src)
if(LIB_POTASSCO_BUILD_TESTS)
	enable_testing()
	add_subdirectory(tests)
endif()
if(LIB_POTASSCO_BUILD_APP)
	add_subdirectory(app)
endif()

# optional doc target
find_package(Doxygen)
if(DOXYGEN_FOUND)
	set(doxyfile "${CMAKE_CURRENT_SOURCE_DIR}/doc/Doxyfile")
	add_custom_target(doc_potassco
		COMMAND ${DOXYGEN_EXECUTABLE} ${doxyfile}
		WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/doc"
		COMMENT "Generating documentation..."
		VERBATIM)
	set_target_properties(doc_potassco PROPERTIES FOLDER doc)
endif()

# export
configure_file(cmake/potassco-config-version.cmake.in
	${CMAKE_CURRENT_BINARY_DIR}/potassco-config-version.cmake
	@ONLY)
if(LIB_POTASSCO_INSTALL_LIB)
	install(FILES cmake/potassco-config.cmake ${CMAKE_CURRENT_BINARY_DIR}/potassco-config-version.cmake DESTINATION "${library_dest}")
	install(EXPORT potassco DESTINATION "${library_dest}")
endif()

=== src/CMakeLists.txt ===
set(header_path ${CLASP_SOURCE_DIR}/clasp)

# generate config.h
set(CLASP_HAS_THREADS ${CLASP_BUILD_WITH_THREADS})
if (CLASP_BUILD_WITH_THREADS)
set(CLASP_DEFINE_ATOMIC "namespace mt { using std::atomic; }")
set(CLASP_ATOMIC_TYPE "std::atomic")
else()
set(CLASP_DEFINE_ATOMIC "
template <class T>
struct Plain {
	T operator=(T nv)   { return (val_ = nv); }
	operator T () const { return val_; }
	operator T&()       { return val_; }
	T exchange(T nVal)  { T oVal = val_; val_ = nVal; return oVal; }
	T fetch_or(T xVal)  { return exchange(val_ | xVal); }
	T fetch_and(T xVal) { return exchange(val_ & xVal); }
	bool compare_exchange_strong(T& oVal, T nVal) {
		if (val_ == oVal) { val_ = nVal;  return true; }
		else              { oVal = val_;  return false; }
	}
	T val_;
};")
set(CLASP_ATOMIC_TYPE "Clasp::Plain")
endif()
if (NOT DEFINED CLASP_USE_STD_VECTOR)
	if (MSVC)
		set(CLASP_USE_STD_VECTOR "_DEBUG")
	else()
		set(CLASP_USE_STD_VECTOR 0)
	endif()
endif()
configure_file(${header_path}/config.h.in ${CLASP_BINARY_DIR}/clasp/config.h @ONLY)

set(header_temp
	${CLASP_BINARY_DIR}/clasp/config.h
	${header_path}/heuristics.h
	${header_path}/statistics.h
	${header_path}/claspfwd.h
	${header_path}/logic_program.h
	${header_path}/pod_vector.h
	${header_path}/weight_constraint.h
	${header_path}/asp_preprocessor.h
	${header_path}/enumerator.h
	${header_path}/clingo.h
	${header_path}/lookahead.h
	${header_path}/shared_context.h
	${header_path}/solver_strategies.h
	${header_path}/solve_algorithms.h
	${header_path}/literal.h
	${header_path}/satelite.h
	${header_path}/program_builder.h
	${header_path}/dependency_graph.h
	${header_path}/clause.h
	${header_path}/cb_enumerator.h
	${header_path}/minimize_constraint.h
	${header_path}/unfounded_check.h
	${header_path}/solver_types.h
	${header_path}/solver.h
	${header_path}/parser.h
	${header_path}/clasp_facade.h
	${header_path}/model_enumerators.h
	${header_path}/logic_program_types.h
	${header_path}/constraint.h)
LIST(APPEND header ${header_temp})
set(ide_header "Header Files")
source_group("${ide_header}" FILES ${header_temp})
set(header_temp
	${header_path}/util/misc_types.h
	${header_path}/util/multi_queue.h
	${header_path}/util/left_right_sequence.h
	${header_path}/util/pod_vector.h
	${header_path}/util/hash.h
	${header_path}/util/indexed_priority_queue.h
	${header_path}/util/type_manip.h
	${header_path}/util/timer.h)
LIST(APPEND header ${header_temp})
source_group("${ide_header}\\util" FILES ${header_temp})
set(header_temp
	${header_path}/cli/clasp_cli_configs.inl
	${header_path}/cli/clasp_cli_options.inl
	${header_path}/cli/clasp_output.h
	${header_path}/cli/clasp_options.h)
LIST(APPEND header ${header_temp})
source_group("${ide_header}\\cli" FILES ${header_temp})

set(src
	asp_preprocessor.cpp
	cb_enumerator.cpp
	clasp_facade.cpp
	clasp_options.cpp
	clasp_output.cpp
	clause.cpp
	clingo.cpp
	constraint.cpp
	dependency_graph.cpp
	enumerator.cpp
	heuristics.cpp
	logic_program.cpp
	logic_program_types.cpp
	lookahead.cpp
	minimize_constraint.cpp
	model_enumerators.cpp
	parser.cpp
	program_builder.cpp
	satelite.cpp
	shared_context.cpp
	solve_algorithms.cpp
	solver.cpp
	solver_strategies.cpp
	solver_types.cpp
	statistics.cpp
	timer.cpp
	unfounded_check.cpp
	weight_constraint.cpp)
if (CLASP_BUILD_WITH_THREADS)
LIST(APPEND src
	parallel_solve.cpp)
set(header_temp
	${header_path}/mt/thread.h
	${header_path}/mt/mutex.h
	${header_path}/mt/parallel_solve.h)
LIST(APPEND header ${header_temp})
source_group("${ide_header}\\mt" FILES ${header_temp})
endif()

add_library(libclasp ${header} ${src})
if (CLASP_BUILD_WITH_THREADS)
	target_link_libraries(libclasp PUBLIC Threads::Threads)
endif()
if(MSVC)
	target_compile_definitions(libclasp PRIVATE _SCL_SECURE_NO_WARNINGS)
	target_compile_options(libclasp PRIVATE "$<$<CONFIG:DEBUG>:/W4>")
	set(VC_RELEASE_OPTIONS /Oi /Oy /GL /Gy /GS-)
	target_compile_definitions(libclasp PUBLIC "$<$<CONFIG:RELEASE>:_SECURE_SCL=0>")
	target_compile_options(libclasp PUBLIC "$<$<CONFIG:RELEASE>:${VC_RELEASE_OPTIONS}>")
	set_target_properties(libclasp PROPERTIES PREFIX "lib")
endif()
target_include_directories(libclasp PUBLIC
	$<BUILD_INTERFACE:${CLASP_SOURCE_DIR}>
	$<BUILD_INTERFACE:${CLASP_BINARY_DIR}>
	$<INSTALL_INTERFACE:${clasp_include_dest}>)
target_link_libraries(libclasp PUBLIC libpotassco)
set_target_properties(libclasp PROPERTIES
	OUTPUT_NAME clasp
	FOLDER lib)

# installation
if (CLASP_INSTALL_LIB)
	install(TARGETS libclasp EXPORT clasp DESTINATION "${clasp_library_dest}")
	install(FILES ${header}               DESTINATION "${clasp_include_dest}/clasp")
endif()

=== libpotassco/app/CMakeLists.txt ===
add_executable(lpconvert lpconvert.cpp)
target_link_libraries(lpconvert libpotassco)
set_target_properties(lpconvert PROPERTIES FOLDER exe)

install(TARGETS lpconvert EXPORT lpconvert DESTINATION "bin")

=== libpotassco/src/CMakeLists.txt ===
set(header_path      ${LIB_POTASSCO_SOURCE_DIR}/potassco)
set(opts_header_path ${header_path}/program_opts)

set(detail_header
	${opts_header_path}/detail/notifier.h
	${opts_header_path}/detail/refcountable.h
	${opts_header_path}/detail/value_store.h)
set(opts_header
	${opts_header_path}/errors.h
	${opts_header_path}/mapped_value.h
	${opts_header_path}/program_options.h
	${opts_header_path}/typed_value.h
	${opts_header_path}/value.h
	${opts_header_path}/value_store.h)
set(header
	${header_path}/application.h
	${header_path}/aspif.h
	${header_path}/aspif_text.h
	${header_path}/basic_types.h
	${header_path}/clingo.h
	${header_path}/convert.h
	${header_path}/match_basic_types.h
	${header_path}/platform.h
	${header_path}/rule_utils.h
	${header_path}/smodels.h
	${header_path}/string_convert.h
	${header_path}/theory_data.h)
set(ide_header_group "Header Files")
source_group("${ide_header_group}" FILES ${header})
source_group("${ide_header_group}\\program_opts" FILES ${opts_header})
source_group("${ide_header_group}\\program_opts\\detail" FILES ${detail_header})
set(src
	application.cpp
	aspif.cpp
	aspif_text.cpp
	clingo.cpp
	convert.cpp
	match_basic_types.cpp
	program_options.cpp
	rule_utils.cpp
	smodels.cpp
	string_convert.cpp
	theory_data.cpp
	value_store.cpp)

add_library(libpotassco ${detail_header} ${opts_header} ${header} ${src})
if(MSVC)
	target_compile_definitions(libpotassco PRIVATE _SCL_SECURE_NO_WARNINGS)
	target_compile_options(libpotassco PRIVATE "/W4" )
	set(VC_RELEASE_OPTIONS /Oi /Oy /GL /Gy)
	target_compile_options(libpotassco PUBLIC "$<$<CONFIG:RELEASE>:${VC_RELEASE_OPTIONS}>")
	set_target_properties(libpotassco PROPERTIES PREFIX "lib")
endif()
target_include_directories(libpotassco PUBLIC
	$<BUILD_INTERFACE:${LIB_POTASSCO_SOURCE_DIR}>
	$<INSTALL_INTERFACE:${include_dest}>)

# properties
set_target_properties(libpotassco PROPERTIES
	OUTPUT_NAME potassco
	FOLDER lib)

# installation
if (LIB_POTASSCO_INSTALL_LIB)
	install(FILES ${header}         DESTINATION "${include_dest}/potassco")
	install(FILES ${opts_header}    DESTINATION "${include_dest}/potassco/program_opts")
	install(FILES ${detail_header}  DESTINATION "${include_dest}/potassco/program_opts/detail")
	install(TARGETS libpotassco     EXPORT potassco DESTINATION "${library_dest}")
endif()

=== debian/changelog ===
clasp (3.3.0-1) unstable; urgency=medium

  * New upstream version 3.3.0
  * debian/copyright: clasp switched to MIT, and so does the packaging
  * debian/rules: build with cmake
  * debian/docs: use README.md
  * set debhelper compatibility level to 10
  * debian/control:
    - Build-Depends on cmake, drop pkg-config
    - add Testsuite: autopkgtest
  * debian/tests:
    - add dep8 testsuite control
    - add clasp0, clasp1, clasp2 tests
  * drop reproducible-build.patch, clasp uses cmake as build system now

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Sun, 07 May 2017 15:02:29 +0200

=== debian/control ===
Source: clasp
Section: interpreters
Priority: extra
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Thomas Krennwallner <tkren@kr.tuwien.ac.at>
Build-Depends: debhelper (>= 10),
 dpkg-dev (>= 1.16.1~),
 g++ (>= 4:6.1.1),
 cmake (>= 3.1.0)
Standards-Version: 3.9.8
Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/clasp.git
Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/clasp.git
Homepage: https://www.potassco.org/clasp/
Testsuite: autopkgtest

Package: clasp
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: gringo
Description: conflict-driven nogood learning answer set solver
 clasp is an answer set solver for (extended) normal logic
 programs. It combines the high-level modeling capacities of answer
 set programming (ASP) with state-of-the-art techniques from the area
 of Boolean constraint solving. The primary clasp algorithm relies on
 conflict-driven nogood learning, a technique that proved very
 successful for satisfiability checking (SAT). Unlike other learning
 ASP solvers, clasp does not rely on legacy software, such as a SAT
 solver or any other existing ASP solver. Rather, clasp has been
 genuinely developed for answer set solving based on conflict-driven
 nogood learning. clasp can be applied as an ASP solver (on LPARSE
 output format), as a SAT solver (on simplified DIMACS/CNF format), or
 as a PB solver (on OPB format).

## clasp 3.3.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.1)
-project(CLASP VERSION 3.3.0 LANGUAGES CXX)
+project(CLASP VERSION 3.3.2 LANGUAGES CXX)
 # Enable folders in IDEs like Visual Studio
 set_property(GLOBAL PROPERTY USE_FOLDERS ON)
 if (POLICY CMP0063)

=== debian/changelog ===
clasp (3.3.2-3) unstable; urgency=medium

  * Switch to g++-6 to work around mips64el FTBFS.
    - debian/rules: force CXX to g++-6
    - debian/control: Build-Depends on g++-6

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Tue, 29 Aug 2017 07:21:44 +0200

clasp (3.3.2-2) unstable; urgency=medium

  * Bug fix: "clasp FTBFS on armel: undefined reference to
    `__atomic_load_8&#39;", thanks to Adrian Bunk (Closes: #872549).
  * debian/rules: link with libatomic on armel

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Mon, 21 Aug 2017 08:31:52 +0200

clasp (3.3.2-1) unstable; urgency=medium

  * New upstream version 3.3.2
  * debian/control: Bump Standards-Version to 4.0.1

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Fri, 18 Aug 2017 07:02:43 +0200

=== debian/control ===
--- 
+++ 
@@ -5,9 +5,9 @@
 Uploaders: Thomas Krennwallner <tkren@kr.tuwien.ac.at>
 Build-Depends: debhelper (>= 10),
  dpkg-dev (>= 1.16.1~),
- g++ (>= 4:6.1.1),
+ g++-6 (>= 6.1.1),
  cmake (>= 3.1.0)
-Standards-Version: 3.9.8
+Standards-Version: 4.0.1
 Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/clasp.git
 Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/clasp.git
 Homepage: https://www.potassco.org/clasp/

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# clasp requires c++11 threads with 64bit __atomic_exchange, we need to
# link with libatomic on armel, powerpc, powerpcspe, m68k, mips, mipsel, and
# sh4, see also
# https://gcc.gnu.org/wiki/Atomic
# https://gcc.gnu.org/wiki/Atomic/GCCMM/LIbrary
arch = $(shell dpkg-architecture -qDEB_BUILD_ARCH | egrep -x "(armel|powerpc|powerpcspe|m68k|mips|mipsel|sh4)")

# use custom hardening config flags for compiling clasp
CONFIG=hardening
CONFIGPARMS = -DLIB_POTASSCO_BUILD_APP=OFF -DCLASP_BUILD_TESTS=ON -DLIB_POTASSCO_BUILD_TESTS=ON -DCLASP_BUILD_EXAMPLES=ON
TOPBUILDDIR = build/$(CONFIG)_mt

#
# export CXXFLAGS and LDFLAGS for configure.sh
#
# add -O3 and NDEBUG and enable all hardening flags
# link with libatomic on architectures without built-in atomic
#
DEB_CXXFLAGS_MAINT_APPEND = -O3 -DNDEBUG
DEB_LDFLAGS_MAINT_APPEND =
ifeq ($(if $(arch),atomic), atomic)
	DEB_LDFLAGS_MAINT_APPEND += -latomic
endif

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

# bug #871514 seems to cause mips64el FTBFS, force g++-6 for now
export CXX = g++-6
export CC = gcc-6
# inject CPPFLAGS to CXXFLAGS
CXXFLAGS += $(CPPFLAGS)

%:
	dh $@

# configure with cmake
override_dh_auto_configure:
	dh_auto_configure --builddirectory=$(TOPBUILDDIR) -- $(CONFIGPARMS)

# build with cmake in $(TOPBUILDDIR)
override_dh_auto_build:
	dh_auto_build --builddirectory=$(TOPBUILDDIR)

# install clasp binary built in $(TOPBUILDDIR)
override_dh_auto_install:
	dh_auto_install --builddirectory=$(TOPBUILDDIR)

# remove the whole build dir
override_dh_auto_clean:
	rm -rf ./build

# run and output test results
override_dh_auto_test:
	dh_auto_test --builddirectory=$(TOPBUILDDIR)
	test -d $(TOPBUILDDIR)/Testing/Temporary && tail -n +1 -v -- $(TOPBUILDDIR)/Testing/Temporary/*

# install CHANGES as changelog
override_dh_installchangelogs:
	dh_installchangelogs CHANGES

## clasp 3.3.3

=== debian/changelog ===
clasp (3.3.3-3) unstable; urgency=medium

  * debian/rules: check DEB_BUILD_PROFILES against nocheck

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Mon, 05 Feb 2018 20:22:21 +0100

clasp (3.3.3-2) unstable; urgency=medium

  * update debian/control and debian/compat
    + update Vcs-Git and Vcs-Browser for salsa
    + bump Standards-Version to 4.1.3
    + bump debhelper compatibility version to 11

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Sat, 03 Feb 2018 13:42:01 +0100

clasp (3.3.3-1) unstable; urgency=medium

  * New upstream version 3.3.3
  * debian/watch: download from /releases/download/vN.N.N
  * drop upstream applied clasp-remove-wrong-assertion.patch

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Sun, 12 Nov 2017 09:11:47 +0100

clasp (3.3.2-4) unstable; urgency=medium

  * debian/control fixes, add Build-Depends on recent g++-7
    + bump Standards-Version to 4.1.1
    + Build-Depends on g++-7 >= 7.2.0-3 for fixed #871514
    + fix priority-extra-is-replaced-by-priority-optional
    + fix unnecessary-testsuite-autopkgtest-header
  * debian/rules: force build with g++-7
  * add clasp-remove-wrong-assertion.patch from upstream commit 02c6d85

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Sat, 04 Nov 2017 10:45:45 +0100

=== debian/control ===
--- 
+++ 
@@ -1,17 +1,16 @@
 Source: clasp
 Section: interpreters
-Priority: extra
+Priority: optional
 Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Thomas Krennwallner <tkren@kr.tuwien.ac.at>
-Build-Depends: debhelper (>= 10),
+Build-Depends: debhelper (>= 11),
  dpkg-dev (>= 1.16.1~),
- g++-6 (>= 6.1.1),
+ g++-7 (>= 7.2.0-3),
  cmake (>= 3.1.0)
-Standards-Version: 4.0.1
-Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/clasp.git
-Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/clasp.git
+Standards-Version: 4.1.3
+Vcs-Git: https://salsa.debian.org/science-team/clasp.git
+Vcs-Browser: https://salsa.debian.org/science-team/clasp
 Homepage: https://www.potassco.org/clasp/
-Testsuite: autopkgtest
 
 Package: clasp
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -33,9 +33,9 @@
 DPKG_EXPORT_BUILDFLAGS = 1
 include /usr/share/dpkg/buildflags.mk
 
-# bug #871514 seems to cause mips64el FTBFS, force g++-6 for now
-export CXX = g++-6
-export CC = gcc-6
+# force g++-7
+export CXX = g++-7
+export CC = gcc-7
 # inject CPPFLAGS to CXXFLAGS
 CXXFLAGS += $(CPPFLAGS)
 
@@ -54,14 +54,16 @@
 override_dh_auto_install:
 	dh_auto_install --builddirectory=$(TOPBUILDDIR)
 
-# remove the whole build dir
 override_dh_auto_clean:
-	rm -rf ./build
+	dh_auto_clean --builddirectory=$(TOPBUILDDIR)
 
 # run and output test results
 override_dh_auto_test:
-	dh_auto_test --builddirectory=$(TOPBUILDDIR)
-	test -d $(TOPBUILDDIR)/Testing/Temporary && tail -n +1 -v -- $(TOPBUILDDIR)/Testing/Temporary/*
+ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
+	dh_auto_test --builddirectory=$(TOPBUILDDIR) &&\
+		{ EXIT_CODE=$$? ; echo "Exit $$EXIT_CODE" ; test -d $(TOPBUILDDIR)/Testing/Temporary && tail -n +1 -v -- $(TOPBUILDDIR)/Testing/Temporary/* ; exit $$EXIT_CODE ; } ||\
+		{ EXIT_CODE=$$? ; echo "Exit $$EXIT_CODE" ; test -d $(TOPBUILDDIR)/Testing/Temporary && tail -n +1 -v -- $(TOPBUILDDIR)/Testing/Temporary/* ; exit $$EXIT_CODE ; }
+endif
 
 # install CHANGES as changelog
 override_dh_installchangelogs:

## clasp 3.3.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.1)
-project(CLASP VERSION 3.3.2 LANGUAGES CXX)
+project(CLASP VERSION 3.3.4 LANGUAGES CXX)
 # Enable folders in IDEs like Visual Studio
 set_property(GLOBAL PROPERTY USE_FOLDERS ON)
 if (POLICY CMP0063)
@@ -10,6 +10,8 @@
 	set(CMAKE_BUILD_TYPE "Release")
 endif()
 list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
+
+include(GNUInstallDirs)
 
 # Configuration options
 option(CLASP_BUILD_APP          "whether or not to build the clasp application" ON)
@@ -40,17 +42,50 @@
 		string(REGEX REPLACE "/MD" "/MT" CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE}")
 	endif()
 endif()
-set(clasp_include_dest  "include/clasp-${CLASP_VERSION}")
-set(clasp_library_dest "lib/clasp-${CLASP_VERSION}")
+set(clasp_include_dest "clasp-${CLASP_VERSION}")
+set(clasp_library_dest "clasp-${CLASP_VERSION}")
+set(cmake_dest         "clasp-${CLASP_VERSION}/cmake")
+
+if (CLASP_INSTALL_LIB AND NOT CMAKE_INSTALL_LIBDIR)
+	message(STATUS "LIBDIR no set - using lib")
+	set(CMAKE_INSTALL_LIBDIR lib)
+endif()
+
 
 # C++11 is required for building with threads
 if (CLASP_BUILD_WITH_THREADS)
 	set(CMAKE_CXX_STANDARD 11)
 	set(CMAKE_CXX_STANDARD_REQUIRED ON)
-	set(CMAKE_CXX_EXTENSIONS OFF)
+	set(CMAKE_CXX_EXTENSIONS ON)
 	# some versions of findThreads will fail if C is not enabled
 	enable_language(C)
 	find_package(Threads REQUIRED)
+
+	# Add libatomic if necessary
+	if (CMAKE_CXX_COMPILER_ID MATCHES "Clang" AND CMAKE_USE_PTHREADS_INIT)
+		include (CheckCXXSourceCompiles)
+		set (OLD_CMAKE_REQUIRED_FLAGS ${CMAKE_REQUIRED_FLAGS})
+		set (OLD_CMAKE_REQUIRED_LIBRARIES ${CMAKE_REQUIRED_LIBRARIES})
+		list(APPEND CMAKE_REQUIRED_FLAGS "-std=c++11")
+		list(APPEND CMAKE_REQUIRED_LIBRARIES Threads::Threads)
+		check_cxx_source_compiles("
+#include <atomic>
+#include <cstdint>
+std::atomic<uint64_t> x (0);
+int main() {
+	uint64_t i = x.load(std::memory_order_relaxed);
+	return 0;
+}
+" CLASP_HAS_WORKING_LIBATOMIC)
+		set (CMAKE_REQUIRED_FLAGS ${OLD_CMAKE_REQUIRED_FLAGS})
+		set (CMAKE_REQUIRED_LIBRARIES ${OLD_CMAKE_REQUIRED_LIBRARIES})
+		if (NOT CLASP_HAS_WORKING_LIBATOMIC)
+			check_library_exists(atomic __atomic_fetch_add_4 "" CLASP_HAS_LIBATOMIC)
+			if (CLASP_HAS_LIBATOMIC)
+				set_property(TARGET Threads::Threads APPEND PROPERTY INTERFACE_LINK_LIBRARIES "atomic")
+			endif()
+		endif()
+	endif()
 endif()
 
 # Check for and optionally build external dependency
@@ -99,7 +134,14 @@
 configure_file(cmake/clasp-config-version.cmake.in
 	${CMAKE_CURRENT_BINARY_DIR}/clasp-config-version.cmake
 	@ONLY)
+
+configure_file(cmake/clasp-config.cmake.in
+	${CMAKE_CURRENT_BINARY_DIR}/clasp-config.cmake
+	@ONLY)
+
 if (CLASP_INSTALL_LIB)
-	install(FILES cmake/clasp-config.cmake ${CMAKE_CURRENT_BINARY_DIR}/clasp-config-version.cmake DESTINATION "${clasp_library_dest}")
-	install(EXPORT clasp DESTINATION "${clasp_library_dest}")
+	install(FILES ${CMAKE_CURRENT_BINARY_DIR}/clasp-config.cmake ${CMAKE_CURRENT_BINARY_DIR}/clasp-config-version.cmake
+	  DESTINATION "${CMAKE_INSTALL_LIBDIR}/${cmake_dest}")
+	install(EXPORT clasp DESTINATION "${CMAKE_INSTALL_LIBDIR}/${cmake_dest}")
 endif()
+

=== debian/changelog ===
clasp (3.3.4-2build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 23 Mar 2020 07:11:25 +0100

clasp (3.3.4-2) unstable; urgency=medium

  * debian/control: bump Standards-Version to 4.2.1
  * Fix reproducible builds FTBFS
    - debian/control: Build-Depends on g++-8
    - debian/rules: force g++-8

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Sun, 04 Nov 2018 16:03:57 +0100

clasp (3.3.4-1) unstable; urgency=medium

  * New upstream version 3.3.4
  * debian/control: bump Standards-Version to 4.1.4

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Sat, 30 Jun 2018 08:31:27 +0200

=== debian/control ===
--- 
+++ 
@@ -5,9 +5,9 @@
 Uploaders: Thomas Krennwallner <tkren@kr.tuwien.ac.at>
 Build-Depends: debhelper (>= 11),
  dpkg-dev (>= 1.16.1~),
- g++-7 (>= 7.2.0-3),
+ g++-8 (>= 8.2.0),
  cmake (>= 3.1.0)
-Standards-Version: 4.1.3
+Standards-Version: 4.2.1
 Vcs-Git: https://salsa.debian.org/science-team/clasp.git
 Vcs-Browser: https://salsa.debian.org/science-team/clasp
 Homepage: https://www.potassco.org/clasp/

=== debian/rules ===
--- 
+++ 
@@ -33,9 +33,9 @@
 DPKG_EXPORT_BUILDFLAGS = 1
 include /usr/share/dpkg/buildflags.mk
 
-# force g++-7
-export CXX = g++-7
-export CC = gcc-7
+# force g++-8
+export CXX = g++-8
+export CC = gcc-8
 # inject CPPFLAGS to CXXFLAGS
 CXXFLAGS += $(CPPFLAGS)

## clasp 3.3.5

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.1)
-project(CLASP VERSION 3.3.4 LANGUAGES CXX)
+project(CLASP VERSION 3.3.5 LANGUAGES CXX)
 # Enable folders in IDEs like Visual Studio
 set_property(GLOBAL PROPERTY USE_FOLDERS ON)
 if (POLICY CMP0063)

=== debian/changelog ===
clasp (3.3.5-5) unstable; urgency=medium

  * Team upload.
  * Bump CMake policy version (Closes: #1112785)

 -- Timo Röhling <roehling@debian.org>  Wed, 24 Sep 2025 22:19:30 +0200

clasp (3.3.5-4.2) unstable; urgency=low

  * Non-maintainer upload.
  * Build using the default gcc. (Closes: #1023678)

 -- Adrian Bunk <bunk@debian.org>  Sat, 19 Nov 2022 12:10:37 +0200

clasp (3.3.5-4.1) unstable; urgency=medium

  * Non-maintainer upload

  [ Lukas Märdian ]
  * Use system-provided catch (Closes: #1004022)

 -- Sebastian Ramacher <sramacher@debian.org>  Wed, 28 Sep 2022 23:21:38 +0200

clasp (3.3.5-4) unstable; urgency=medium

  * Bug fix: "non-standard gcc/g++ used for build (gcc-9)", thanks to
    Matthias Klose (Closes: #978509).

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Mon, 28 Dec 2020 12:26:04 +0000

clasp (3.3.5-3) unstable; urgency=medium

  * Upload to unstable

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Sun, 27 Dec 2020 01:15:36 +0000

clasp (3.3.5-2) experimental; urgency=medium

  [ Debian Janitor ]
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.
  * Fix day-of-week for changelog entry 1.3.2-2.

  [ Thomas Krennwallner ]
  * debian/control: bump Build-Depends to debhelper-compat 13
  * debian/control: bump Standards-version to 4.5.1 (no changes required)
  * compile with g++-10 >= 10.2.1
  * Set upstream metadata fields: Changelog, Contact, FAQ, Name,
    Other-References, Reference

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Sat, 26 Dec 2020 21:25:44 +0000

clasp (3.3.5-1) unstable; urgency=medium

  * New upstream version 3.3.5

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Sun, 15 Mar 2020 14:27:36 -0400

clasp (3.3.4-4) unstable; urgency=medium

  * debian/patches: add link-libatomic-check-gcc.patch

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Fri, 13 Mar 2020 06:22:27 -0400

clasp (3.3.4-3) unstable; urgency=medium

  * compile with g++-9
  * Bug fix: "non-standard gcc/g++ used for build (gcc-8)", thanks to
    Matthias Klose (Closes: #944176).
  * debian/rules: don't confuse build target with build directory, disable
    libatomic checks
  * debian/control: bump Standards-Version to 4.5.0 (no changes required),
    set Rules-Requires-Root to no
  * setup debhelper-compat 12

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Thu, 12 Mar 2020 08:17:17 -0400

=== debian/control ===
--- 
+++ 
@@ -3,11 +3,12 @@
 Priority: optional
 Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Thomas Krennwallner <tkren@kr.tuwien.ac.at>
-Build-Depends: debhelper (>= 11),
+Build-Depends: debhelper-compat (= 13),
  dpkg-dev (>= 1.16.1~),
- g++-8 (>= 8.2.0),
+ catch,
  cmake (>= 3.1.0)
-Standards-Version: 4.2.1
+Rules-Requires-Root: no
+Standards-Version: 4.5.1
 Vcs-Git: https://salsa.debian.org/science-team/clasp.git
 Vcs-Browser: https://salsa.debian.org/science-team/clasp
 Homepage: https://www.potassco.org/clasp/

=== debian/rules ===
--- 
+++ 
@@ -4,38 +4,25 @@
 # Uncomment this to turn on verbose mode.
 #export DH_VERBOSE=1
 
-# clasp requires c++11 threads with 64bit __atomic_exchange, we need to
-# link with libatomic on armel, powerpc, powerpcspe, m68k, mips, mipsel, and
-# sh4, see also
-# https://gcc.gnu.org/wiki/Atomic
-# https://gcc.gnu.org/wiki/Atomic/GCCMM/LIbrary
-arch = $(shell dpkg-architecture -qDEB_BUILD_ARCH | egrep -x "(armel|powerpc|powerpcspe|m68k|mips|mipsel|sh4)")
-
 # use custom hardening config flags for compiling clasp
 CONFIG=hardening
-CONFIGPARMS = -DLIB_POTASSCO_BUILD_APP=OFF -DCLASP_BUILD_TESTS=ON -DLIB_POTASSCO_BUILD_TESTS=ON -DCLASP_BUILD_EXAMPLES=ON
-TOPBUILDDIR = build/$(CONFIG)_mt
+CONFIGPARMS = -DLIB_POTASSCO_BUILD_APP=OFF -DCLASP_BUILD_TESTS=ON -DLIB_POTASSCO_BUILD_TESTS=ON -DCLASP_BUILD_EXAMPLES=ON \
+	      -DCMAKE_POLICY_VERSION_MINIMUM=3.10
+TOPBUILDDIR = build.dir/$(CONFIG)_mt
 
 #
-# export CXXFLAGS and LDFLAGS for configure.sh
+# export CXXFLAGS and LDFLAGS for cmake
 #
-# add -O3 and NDEBUG and enable all hardening flags
-# link with libatomic on architectures without built-in atomic
+# default to -O3 -Wall -DNDEBUG and enable all hardening flags
 #
-DEB_CXXFLAGS_MAINT_APPEND = -O3 -DNDEBUG
-DEB_LDFLAGS_MAINT_APPEND =
-ifeq ($(if $(arch),atomic), atomic)
-	DEB_LDFLAGS_MAINT_APPEND += -latomic
-endif
+DEB_CXXFLAGS_MAINT_APPEND = -O3 -Wall
+DEB_CPPFLAGS_MAINT_APPEND = -DNDEBUG
 
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 
 DPKG_EXPORT_BUILDFLAGS = 1
 include /usr/share/dpkg/buildflags.mk
 
-# force g++-8
-export CXX = g++-8
-export CC = gcc-8
 # inject CPPFLAGS to CXXFLAGS
 CXXFLAGS += $(CPPFLAGS)

=== debian/tests/control ===
Tests: clasp0, clasp1, clasp2
Depends: gringo, @
